/***********************************************************
hb.c
	Hypertext BROWSER
	Link w/ popup.obj,sayerr.obj,mouse.obj,fileio.obj,vstr.obj,vlr.obj.
*/
#include <stdio.h>
#include <dir.h>
#include <string.h>
#include <process.h>
#include <ctype.h>
#include <conio.h>
#include <alloc.h>
#include "vstr.h"
#include "mouse.h"
#include "popup.h"
#include "fileio.h"
#include "vlr.h"

#define MAX(a,b)  ((a) > (b) ? (a) : (b))
#define MIN(a,b)  ((a) < (b) ? (a) : (b))
#define MAXLINESIZE 128
#define MAXKEYSIZE 21
#define INDEX ((index_elem *)(index.data))

typedef struct
{
	char key[MAXKEYSIZE];
	long txt_addr;
	long key_addr;
	int wd,ht;
} index_elem;
typedef struct
{
	int x,y, wd,keyno;
} key_pos_elem;

index_elem index_key = { "Home",  0L,0L,52,10 };
index_elem stack_key = { "Stack", 0L,0L,52,10 };

static void paint_htx(windesc *mw, vstr *keypos,vstr *text);
static int get_next_card(windesc *w, vstr *keypos);
static int on_key(vstr *keypos, int x, int y);
static void make_index_card(vstr *index, vstr *index_card, vstr *stack, vstr *keypos, int wd);
static void move_curr_win(int x, int y);
static int mouse_on_border(windesc *, int *xofs, int *yofs);
static void recolor(windesc *w, int attr);
char *cmds[] = { "Home","Stack","Prev","Next","Delete","Quit"};
key_pos_elem cmd_menu[6];
vstr index = NULLVSTR;
vstr card = NULLVSTR;
vstr keypos = NULLVSTR;
vstr keystack = NULLVSTR;
vstr winstack = NULLVSTR;
vstr indxstk = NULLVSTR;
wincolors deadcolors = {1,7,7,7,7};
char infile[MAXPATH];
int fhtx;

void main(int argc, char *argv[])
{
	int i, cardno,newcardno,command,dx,wd,ht;
	long fs,fe,ita,nl;
	init_win();
	init_files();
	init_mouse(MOUSE_OPTIONAL,MOUSE_TEXT_MODE,MOUSE_TEXT_MODE);
	if (argc < 2)
	{
		printf("Usage: >hd hypertxtfile\nExtension of 'htx' assumed\n");
		exit(1);
	}
	strcpy(infile,argv[1]);
	strcat(infile,".htx");
	if ((fhtx = openvlr(infile,"rb",32L)) == -1)   exit(1);
	clrvstr(&index,30,sizeof(index_elem),10);
	readhdr(fhtx,&fs,&fe,&ita,&nl);
	nl = (nl-1)/2;
	printf("Should be %ld keys\n",nl);
	if (getvlr(fhtx,&index,ita) == -1)   exit(1);
	printf("index says there are %d\n", index.currlen);
	for (i=0; i<index.currlen; i++)
	{
		printf("%d %s %ld\n", i, INDEX[i].key, INDEX[i].txt_addr);
	}
	printf("Press a key to get started ...\n");
	getch();
	clrscr();
	vstrins(&index,0,&index_key,1);
	vstrins(&index,1,&stack_key,1);
	clrvstr(&keystack,15,sizeof(int),0);
	clrvstr(&winstack,15,sizeof(windesc *),0);
	clrvstr(&indxstk,15,sizeof(int),10);
	for (i=0; i<index.currlen; i++)
	{
		vstrcat(&indxstk,&i);
	}
	cardno = 0;  command = -1;
	while(cardno != -1)
	{
		for (i=0; i<keystack.currlen; i++)
		{
			if (((int *)(keystack.data))[i] == cardno) break;
		}
		if (keystack.currlen) recolor(curr_win,7);
		if (i < keystack.currlen)
		{
			slct_win( ((windesc **)(winstack.data))[i] );
			vstrdel(&keystack,i,1);
			vstrdel(&winstack,i,1);
		}
		else
		{
			if (keystack.currlen == 15)
			{
				rmv_win( ((windesc **)(winstack.data))[winstack.currlen-1]);
				winstack.currlen--;
				keystack.currlen--;
			}
			wd = MAX(INDEX[cardno].wd+2,52) + 1;
			ht = MAX(INDEX[cardno].wd+6,7) + 1;
			draw_win(curr_win->xul+2,curr_win->yul+1,
				wd,ht,INDEX[cardno].key,popup,&monocolors);
		}
		vstrcat(&keystack,&cardno);
		vstrcat(&winstack,&curr_win);
		clrvstr(&card,500,sizeof(char),100);
		clrvstr(&keypos,10,sizeof(key_pos_elem),5);
		if (cardno == 0)
		{
			make_index_card(&index, &indxstk, &card, &keypos, index_key.wd);
		}
		else
		{
			if (cardno == 1)
			{
				make_index_card(&index, &keystack, &card, &keypos, stack_key.wd);
			}
			else
			{
				getvlr(fhtx,&card, INDEX[cardno].txt_addr);
				getvlr(fhtx,&keypos, INDEX[cardno].key_addr);
				for (i=0; i<keypos.currlen; i++)
				{
					((key_pos_elem *)(keypos.data))[i].y += 2;
				}
			}
		}
		vstrcat(&card,"");
		prtfstr(1,1," ", curr_win->wc.hilite_color, -80);
		for (i=0, dx=1; i<6; i++)
		{
			cmd_menu[i].keyno = index.currlen + i;
			cmd_menu[i].x     = dx;
			cmd_menu[i].y     = 1;
			prtfstr(dx,1, cmds[i], curr_win->wc.hilite_color,80);
			dx += strlen(cmds[i]);
			cmd_menu[i].wd = strlen(cmds[i]);
			dx =dx +2;
		}
		prtfstr(1,2, "\xc4", curr_win->wc.border_color, -80);
		prtfstr(1,curr_win->ht-3, "\xc4", curr_win->wc.border_color, -80);
		prtfstr(1,curr_win->ht-2, " ", curr_win->wc.hilite_color, -80);
		prtfstr(1,curr_win->ht-2, "%3d of %3d", curr_win->wc.hilite_color, 80, cardno+1, index.currlen);
		paint_htx(curr_win,&keypos,&card);
		vstrins(&keypos,keypos.currlen,cmd_menu,6);
		newcardno = get_next_card(curr_win, &keypos);
		if (newcardno < index.currlen)
		{
			cardno = newcardno;
			command = -1;
		}
		else
		{
			command = newcardno - index.currlen;
			switch(command)
			{
				case 0:
					cardno = 0;
					break;
				case 1:
					cardno = 1;
					break;
				case 2:
					if (--cardno < 2) cardno = index.currlen-1;
					break;
				case 3:
					if (++cardno == index.currlen)  cardno = 2;
					break;
				case 4:
					if (keystack.currlen > 1)
					{
						rmv_win(curr_win);
						keystack.currlen--;
						winstack.currlen--;
					}
					cardno = ((int *)(keystack.data))[keystack.currlen-1];
					break;
				case 5:
					cardno = -1;
					break;
				default:  ;
			}
		}
		if (command == 5)   break;
	}
	closefile(fhtx);
	mouse_off(0);
	for (i = winstack.currlen; i>0; i--)  rmv_win(curr_win);
}

#define htx ((unsigned char *)(text->data))
static void paint_htx(windesc *w, vstr *keypos, vstr *text)
{
	int i,j;
	static texel line[80];
	key_pos_elem kp;
	mouse_off(1);
	gotoxy(1,3);
	cprintf("%s",text->data);
	for (i=0; i<keypos->currlen; i++)
	{
		kp = ((key_pos_elem *)(keypos->data))[i];
		kp.x += w->xul;  kp.y += w->yul;
		gettext(kp.x,kp.y,kp.x + kp.wd + 1, kp.y, line);
		for (j=0; j<kp.wd; j++)  line[j].attr = w->wc.hilite_color;
		puttext(kp.x,kp.y,kp.x + kp.wd + 1, kp.y, line);
	}
	mouse_on(1);
}
static int get_next_card(windesc *w, vstr *keypos)
{
	int x,y,xofs,yofs,done;
	unsigned int key;
	int keyno;
	x = 1;  y = 3;  keyno = -1;
	do
	{
		gotoxy(x,y);
		if ((key = mouse_trigger(0)) || (key = mouse_trigger(1)))
		{
			done = 1;
			switch(key)
			{
				case LEFT_MOUSE_PRESS:
					if (mouse_on_border(w,&xofs,&yofs))
					{
						while(button_state())
						{
							mouse_txt_posn(&x,&y);
							move_curr_win(x-xofs,y-yofs);
						}
					}
					done = 0;
					break;
				case LEFT_MOUSE_REL:
					x = mouse_text_x - curr_win->xul;
					y = mouse_text_y - curr_win->yul;
					gotoxy(x,y);
					if ((keyno = on_key(keypos,x,y)) == -1) done = 0;
					break;
				case CRKEY:
					if ((keyno = on_key(keypos,x,y)) == -1) done = 0;
					break;
				case UPKEY:
					if (!(--y)) y = 1;
					done = 0;
					break;
				case DOWNKEY:
					if (++y > w->ht-2) y = w->ht-2;
					done = 0;
					break;
				case LEFTKEY:
					if (!(--x)) x = 1;
					done = 0;
					break;
				case RIGHTKEY:
					if (++x > w->wd-2)  x = w->wd-2;
					done = 0;
					break;
				case HOMEKEY:
				case 0x2368:
				case 0x2348:
					keyno = index.currlen;
					break;
				case 0x1f73:
				case 0x1f53:
					keyno = index.currlen + 1;
					break;
				case PGUPKEY:
				case 0x1970:
				case 0x1950:
					keyno = index.currlen + 2;
					break;
				case PGDNKEY:
				case 0x316e:
				case 0x314e:
					keyno = index.currlen + 3;
					break;
				case BSKEY:
				case DELKEY:
				case 0x2064:
				case 0x2044:
					keyno = index.currlen + 4;
					break;
				case RIGHT_MOUSE_REL:
				case ESCKEY:
				case 0x1071:
				case 0x1051:
					keyno = index.currlen + 5;
					break;
				case SHFTUPKEY:
					move_curr_win(curr_win->xul,curr_win->yul-1);
					done = 0;
					break;
				case SHFTDNKEY:
					move_curr_win(curr_win->xul,curr_win->yul+1);
					done=0;
					break;
				case SHFTLEFT:
					move_curr_win(curr_win->xul-1,curr_win->yul);
					done = 0;
					break;
				case SHFTRIGHT:
					move_curr_win(curr_win->xul+1,curr_win->yul);
					done = 0;
					break;
				default:  ;
			}
		}
		else
		{
			done = 0;
		}
	}  while(!done);
	return keyno;
}
static int on_key(vstr *keypos, int x, int y)
{
	int i;
	key_pos_elem kp;
	for (i = 0; i<keypos->currlen; i++)
	{
		kp = ((key_pos_elem *)(keypos->data))[i];
		if ((y == kp.y) && (x >= kp.x) && (x <= kp.x + kp.wd -1))
			return kp.keyno;
	}
	return -1;
}
static void make_index_card(vstr *index, vstr *keystack, vstr *index_card, vstr *keypos, int wd)
{
	int i,k,keylen,col,row;
	key_pos_elem kp;
	char *keystr;
	for (i=0,col=1,row=3; i<keystack->currlen; i++)
	{
		k = ((int *)(keystack->data))[i];
		keystr = ((index_elem *)(index->data))[k].key;
		keylen = strlen(keystr);
		if ((col + keylen + 2) > wd)
		{
			col = 1;  row++;
			vstrcat(index_card,"\n");
		}
		kp.x = col;  kp.y = row;
		kp.keyno = k;  kp.wd = keylen;
		vstrcat(keypos, &kp);
		col += keylen + 2;
		vstrins(index_card,index_card->currlen,keystr,keylen);
		vstrins(index_card,index_card->currlen, "  ", 2);
	}
}
static void recolor(windesc *w, int attr)
{
	texel *ip;
	int numtexels,i;
	numtexels = (w->xlr - w->xul + 1) * (w->ylr - w->yul + 1);
	ip = (texel *) malloc(numtexels*2);
	mouse_off(1);
	gettext(w->xul,w->yul,w->xlr,w->ylr,ip);
	for (i=0; i<numtexels; i++)
	{
		ip[i].attr = attr;
	}
	puttext(w->xul,w->yul,w->xlr,w->ylr,ip);
	mouse_on(1);
	free(ip);
}
static int mouse_on_border(windesc *w,int *xofs, int *yofs)
{
	int x,y;
	mouse_txt_posn(&x,&y);
	if ((x >= w->xul && x <= w->xlr &&
	     y >= w->yul && y <= w->ylr) &&
	     (x == w->xul || x == w->xlr ||
	      y == w->yul || y == w->ylr))
	{
		*xofs = x - w->xul;  *yofs = y - w->yul;
		return 1;
	}
	return 0;
}
static void move_curr_win(int x, int y)
{
	int xsave,ysave;
	x = MAX(x,1);
	x = MIN(x,81-curr_win->wd);
	y = MAX(y,1);
	y = MIN(y,26-curr_win->ht);
	if (x != curr_win->xul || y != curr_win->yul)
	{
		xsave = wherex();
		ysave = wherey();
		swap_image(curr_win);
		curr_win->xul = x;
		curr_win->yul = y;
		curr_win->xlr = curr_win->xul + curr_win->wd-1;
		curr_win->ylr = curr_win->yul + curr_win->ht-1;
		swap_image(curr_win);
		window(curr_win->xul+1,curr_win->yul+1,
			curr_win->xlr-1,curr_win->ylr-1);
		gotoxy(xsave,ysave);
	}
}
